<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 26/03/20
 * Time: 9.00
 */

namespace FiloBlu\Rma\Block\Email\ChangeSizeOrder;
use FiloBlu\Rma\Api\RmaExtensionAttributesRepositoryInterface;
use Magento\Framework\View\Element\Template\Context;
use Magento\Framework\Data\Collection\ModelFactory;
use Magento\Eav\Model\Form\Factory;
use Magento\Eav\Model\Config;
use Magento\Rma\Helper\Eav;
use Magento\Rma\Block\Email\Items;
use Magento\Rma\Api\RmaRepositoryInterface;

class Details extends Items
{
    /**
     * @var RmaExtensionAttributesRepositoryInterface
     */
    private $rmaExtensionAttributesRepository;
    /**
     * @var RmaRepositoryInterface
     */
    private $rmaRepository;


    /**
     * Details constructor.
     * @param Context $context
     * @param ModelFactory $modelFactory
     * @param Factory $formFactory
     * @param Config $eavConfig
     * @param Eav $rmaEav
     * @param RmaExtensionAttributesRepositoryInterface $rmaExtensionAttributesRepository
     * @param RmaRepositoryInterface $rmaRepository
     * @param array $data
     */
    public function __construct(
        Context $context, 
        ModelFactory $modelFactory, 
        Factory $formFactory, 
        Config $eavConfig, 
        Eav $rmaEav,
        RmaExtensionAttributesRepositoryInterface $rmaExtensionAttributesRepository,
        RmaRepositoryInterface $rmaRepository,
        array $data = [])
    {
        parent::__construct($context, $modelFactory, $formFactory, $eavConfig, $rmaEav, $data);
        $this->rmaExtensionAttributesRepository = $rmaExtensionAttributesRepository;
        $this->rmaRepository = $rmaRepository;
    }


    /**
     * @param \Magento\Sales\Api\Data\OrderInterface $order
     * @return string
     */
    public function getChangeSizeOrderDetails(\Magento\Sales\Api\Data\OrderInterface $order){
        try{
            $additionals = $order->getPayment()->getAdditionalInformation();
            if($additionals === null){
                return "";
            }

            if(isset($additionals['rma_id'])){
                $rma = $this->rmaRepository->get($additionals['rma_id']);
                return $rma->getIncrementId();
            }
        }catch (\Exception $e){
            $this->_logger->critical($e->getMessage());
            return "";
        }catch (\Throwable $t){
            $this->_logger->critical($t->getMessage());
            return "";
        }
    }


}